MacDocParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MacDocParser Class Referencefinal

the main class to read a MacDoc file More...

`#include <MacDocParser.hxx>`

Inheritance diagram for MacDocParser:

## Public Member Functions
| MacDocParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~MacDocParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
const MWAWPageSpan & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | sendContents ()
| try to send the contents More...
bool | sendPicture (MWAWEntry const &entry)
| try to send a picture More...
bool | readFont (MWAWEntry const &entry)
| try to read a font index entry More...
bool | readIndex (MWAWEntry const &entry)
| try to read an index entry More...
int | updateIndex (int actIndex, int actLevel)
| try to set the index level and return the next index value (or -1) More...
bool | readBookmark (MWAWEntry const &entry)
| try to read a bookmark entry More...
bool | readFile (MWAWEntry const &entry)
| try to read a file entry More...
bool | readWP (MWAWEntry const &entry)
| try to read a MDwp entry (window pos?) More...
bool | sendIndex ()
| try to send the index More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
const std::string & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< MacDocParserInternal::State > | m_state
| the state More...

## Detailed Description

the main class to read a MacDoc file

## Constructor & Destructor Documentation

## ◆ MacDocParser()

MacDocParser::MacDocParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MacDocParser()

MacDocParser::~MacDocParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MacDocParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MacDocParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MacDocParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ init()

void MacDocParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MacDocParser().

## ◆ newPage()

void MacDocParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendContents().

## ◆ parse()

void MacDocParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readBookmark()

bool MacDocParser::readBookmark | ( | MWAWEntry const & | entry | ) |
| protected

try to read a bookmark entry

Referenced by createZones().

## ◆ readFile()

bool MacDocParser::readFile | ( | MWAWEntry const & | entry | ) |
| protected

try to read a file entry

Referenced by createZones().

## ◆ readFont()

bool MacDocParser::readFont | ( | MWAWEntry const & | entry | ) |
| protected

try to read a font index entry

Referenced by createZones().

## ◆ readIndex()

bool MacDocParser::readIndex | ( | MWAWEntry const & | entry | ) |
| protected

try to read an index entry

Referenced by createZones().

## ◆ readWP()

bool MacDocParser::readWP | ( | MWAWEntry const & | entry | ) |
| protected

try to read a MDwp entry (window pos?)

Referenced by createZones().

## ◆ rsrcAscii()

libmwaw::DebugFile & MacDocParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), readBookmark(), readFile(), readFont(), readIndex(), and readWP().

## ◆ rsrcInput()

MWAWInputStreamPtr MacDocParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by readBookmark(), readFile(), readFont(), readIndex(), readWP(), and sendIndex().

## ◆ sendContents()

bool MacDocParser::sendContents | ( |  | ) |
| protected

try to send the contents

Referenced by parse().

## ◆ sendIndex()

bool MacDocParser::sendIndex | ( |  | ) |
| protected

try to send the index

Referenced by sendContents().

## ◆ sendPicture()

bool MacDocParser::sendPicture | ( | MWAWEntry const & | entry | ) |
| protected

try to send a picture

Referenced by sendContents().

## ◆ updateIndex()

int MacDocParser::updateIndex | ( | int | actIndex,
|  | int | actLevel
| ) |  |
| protected

try to set the index level and return the next index value (or -1)

Referenced by sendIndex().

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MacDocParserInternal::State> MacDocParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), newPage(), readFont(), readIndex(), sendContents(), sendIndex(), and updateIndex().

The documentation for this class was generated from the following files:

- MacDocParser.hxx
- MacDocParser.cxx